var init =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.guessWindowXID = exports.getWindowXid = exports.getWindowClassName = exports.execute = exports.clearTimeout = exports.setTimeout = exports.clearInterval = exports.setInterval = exports.logger = void 0;
const Gio_2_0_1 = __webpack_require__(4);
const GLib_2_0_1 = __webpack_require__(5);
exports.logger = (prefix) => (content) => log(`[mtt] [${prefix}] ${content}`);
exports.setInterval = (func, millis) => {
    const id = GLib_2_0_1.timeout_add(GLib_2_0_1.PRIORITY_DEFAULT, millis, () => {
        func();
        return true;
    });
    return id;
};
exports.clearInterval = (id) => GLib_2_0_1.Source.remove(id);
exports.setTimeout = (func, millis) => {
    return GLib_2_0_1.timeout_add(GLib_2_0_1.PRIORITY_DEFAULT, millis, () => {
        func();
        return false;
    });
};
exports.clearTimeout = (id) => GLib_2_0_1.Source.remove(id);
exports.execute = (command) => __awaiter(void 0, void 0, void 0, function* () {
    const process = new Gio_2_0_1.Subprocess({
        argv: ['bash', '-c', command],
        flags: Gio_2_0_1.SubprocessFlags.STDOUT_PIPE,
    });
    process.init(null);
    return new Promise((resolve, reject) => {
        process.communicate_utf8_async(null, null, (_, result) => {
            const [, stdout, stderr] = process.communicate_utf8_finish(result);
            if (stderr) {
                reject(stderr);
            }
            else if (stdout) {
                resolve(stdout.trim());
            }
            else {
                resolve();
            }
        });
    });
});
exports.getWindowClassName = (xid) => __awaiter(void 0, void 0, void 0, function* () {
    const xpropOut = yield exports.execute(`xprop -id ${xid} WM_CLASS`);
    return xpropOut.split('=')[1].split(',')[0].trim().split('"')[1];
});
exports.getWindowXid = () => __awaiter(void 0, void 0, void 0, function* () {
    return exports.execute('xdotool selectwindow');
});
/**
 * Taken from pixel saver extension. https://github.com/pixel-saver/pixel-saver
 *
 * Guesses the X ID of a window.
 */
exports.guessWindowXID = (window) => __awaiter(void 0, void 0, void 0, function* () {
    // We cache the result so we don't need to redetect.
    // if (window._mttWindowId) {
    //   return window._mttWindowId;
    // }
    /**
     * If window title has non-utf8 characters, get_description() complains
     * "Failed to convert UTF-8 string to JS string: Invalid byte sequence in conversion input",
     * event though get_title() works.
     */
    try {
        const m = window.get_description().match(/0x[0-9a-f]+/);
        if (m && m[0]) {
            // return (win._pixelSaverWindowID = m[0]);
            return m[0];
        }
    }
    catch (err) { }
    // use xwininfo, take first child.
    const act = window.get_compositor_private();
    const xwindow = act && act['x-window'];
    if (xwindow) {
        const xwininfo = yield exports.execute(`xwininfo -children -id 0x${xwindow}`);
        if (xwininfo[0]) {
            const str = xwininfo[1].toString();
            /**
             * The X ID of the window is the one preceding the target window's title.
             * This is to handle cases where the window has no frame and so
             * act['x-window'] is actually the X ID we want, not the child.
             */
            const regexp = new RegExp(`(0x[0-9a-f]+) +"${window.title}"`);
            let m = str.match(regexp);
            if (m && m[1]) {
                // return (win._pixelSaverWindowID = m[1]);
                return m[1];
            }
            // Otherwise, just grab the child and hope for the best
            m = str.split(/child(?:ren)?:/)[1].match(/0x[0-9a-f]+/);
            if (m && m[0]) {
                // return (win._pixelSaverWindowID = m[0]);
                return m[0];
            }
        }
    }
    // Try enumerating all available windows and match the title. Note that this
    // may be necessary if the title contains special characters and `x-window`
    // is not available.
    const result = yield exports.execute('xprop -root _NET_CLIENT_LIST');
    if (result[0]) {
        const str = result[1].toString();
        // Get the list of window IDs.
        const windowList = str.match(/0x[0-9a-f]+/g);
        if (windowList) {
            // For each window ID, check if the title matches the desired title.
            for (let i = 0; i < windowList.length; ++i) {
                const result = yield exports.execute(`xprop -id "${windowList[i]}" _NET_WM_NAME`);
                if (result[0]) {
                    const output = result[1].toString();
                    const title = output.match(/_NET_WM_NAME(\(\w+\))? = "(([^\\"]|\\"|\\\\)*)"/);
                    // Is this our guy?
                    if (title && title[2] == window.title) {
                        return windowList[i];
                    }
                }
            }
        }
    }
});


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(2);


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.MttExtension = void 0;
__webpack_require__(3);
const utils_1 = __webpack_require__(0);
const listener_1 = __webpack_require__(6);
const debug = utils_1.logger('extension');
class MttExtension {
    constructor() {
        this.listener = new listener_1.WindowListener();
        debug('extension is initialized');
    }
    enable() {
        this.listener.enable();
        debug('extension is enabled');
    }
    disable() {
        this.listener.disable();
        debug('extension is disabled');
    }
}
exports.MttExtension = MttExtension;
function default_1() {
    return new MttExtension();
}
exports.default = default_1;


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

// extracted by mini-css-extract-plugin

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = imports.gi.Gio;


/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = imports.gi.GLib;


/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WindowListener = void 0;
const utils_1 = __webpack_require__(0);
const St_1_0_1 = __webpack_require__(7);
const shell_1 = __webpack_require__(8);
const Shell_0_1_1 = __webpack_require__(9);
const Meta_6_1 = __webpack_require__(10);
const Wnck_3_0_1 = __webpack_require__(11);
const Clutter_6_1 = __webpack_require__(12);
const { Button } = imports.ui.panelMenu;
const { panel } = imports.ui.main;
const debug = utils_1.logger(_('window-listener'));
class WindowListener {
    constructor() {
        this.settings = shell_1.getCurrentExtensionSettings();
        this.mttData = [];
        this.trackedWindows = [];
        // Initialize values
        this.initValues();
    }
    enable() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.initExtensionState();
            // Watch for settings changes
            this.settings.connect('changed::mtt-data', this.onSettingsChanged.bind(this));
            // Check for currently opened windows, if they match our data, we track the window
            const existingWindows = Shell_0_1_1.Global.get().get_window_actors();
            for (let i = 0; i < existingWindows.length; i++) {
                const window = existingWindows[i].get_meta_window();
                if (!window.get_wm_class_instance() || window.get_window_type() != Meta_6_1.WindowType.NORMAL) {
                    continue;
                }
                const xid = yield utils_1.guessWindowXID(window);
                if (xid) {
                    yield this.trackWindow(xid, window);
                }
            }
            // Watch for window-opened events
            this.windowOpenedListenerId = Shell_0_1_1.Global.get().display.connect('window-created', (_, window) => __awaiter(this, void 0, void 0, function* () {
                if (window.get_window_type() !== Meta_6_1.WindowType.NORMAL || !window.get_wm_class_instance()) {
                    return;
                }
                const xid = yield utils_1.guessWindowXID(window);
                if (xid) {
                    debug(`new window opened for class: ${window.get_id()}/${window.get_wm_class_instance()}`);
                    yield this.trackWindow(xid, window);
                }
            }));
            // Watch for window-closed events
            this.windowClosedListenerId = Shell_0_1_1.Global.get().window_manager.connect('destroy', (_, windowActor) => __awaiter(this, void 0, void 0, function* () {
                if (windowActor.get_meta_window().get_window_type() !== Meta_6_1.WindowType.NORMAL ||
                    !windowActor.get_meta_window().get_wm_class_instance()) {
                    return;
                }
                const xid = yield utils_1.guessWindowXID(windowActor.get_meta_window());
                if (xid) {
                    yield this.unTrackWindow(xid);
                    debug(`window closed for class: ${xid}/${windowActor.get_meta_window().get_wm_class_instance()}`);
                }
            }));
            // Watch for window-changed events
            this.windowChangedListenerId = Shell_0_1_1.WindowTracker.get_default().connect('tracked-windows-changed', () => __awaiter(this, void 0, void 0, function* () {
                const existingWindows = Shell_0_1_1.Global.get().get_window_actors();
                for (let i = 0; i < existingWindows.length; i++) {
                    const window = existingWindows[i].get_meta_window();
                    if (!window.get_wm_class_instance() || window.get_window_type() != Meta_6_1.WindowType.NORMAL) {
                        continue;
                    }
                    const xid = yield utils_1.guessWindowXID(window);
                    if (xid) {
                        yield this.trackWindow(xid, window);
                    }
                }
            }));
            // Watch for window-closed events
            this.windowClosedListenerId = Shell_0_1_1.Global.get().window_manager.connect('minimize', (_, windowActor) => __awaiter(this, void 0, void 0, function* () {
                if (windowActor.get_meta_window().get_window_type() !== Meta_6_1.WindowType.NORMAL ||
                    !windowActor.get_meta_window().get_wm_class_instance()) {
                    return;
                }
                const xid = yield utils_1.guessWindowXID(windowActor.get_meta_window());
                if (xid) {
                    const window = this.trackedWindows.find((trackedWindow) => trackedWindow.xid === xid);
                    if (window) {
                        this.hideWindow(xid);
                        debug(`window is minimized for class: ${xid}/${windowActor.get_meta_window().get_wm_class_instance()}`);
                    }
                }
            }));
            debug('started listening for windows');
        });
    }
    disable() {
        // Dont watch for window-opened event anymore
        if (this.windowOpenedListenerId != undefined) {
            Shell_0_1_1.Global.get().display.disconnect(this.windowOpenedListenerId);
            this.windowOpenedListenerId = undefined;
        }
        // Dont watch for window-closed event anymore
        if (this.windowClosedListenerId != undefined) {
            Shell_0_1_1.Global.get().window_manager.disconnect(this.windowClosedListenerId);
            this.windowClosedListenerId = undefined;
        }
        // Dont watch for windows-changed event anymore
        if (this.windowChangedListenerId != undefined) {
            Shell_0_1_1.WindowTracker.get_default().disconnect(this.windowChangedListenerId);
            this.windowChangedListenerId = undefined;
        }
        // Dont watch for windows-minimized event anymore
        if (this.windowMinimizedListenerId != undefined) {
            Shell_0_1_1.Global.get().window_manager.disconnect(this.windowMinimizedListenerId);
            this.windowMinimizedListenerId = undefined;
        }
        // Save the state
        this.settings.set_string('extension-state', JSON.stringify(this.trackedWindows));
        // Untrack windows
        this.trackedWindows.forEach((trackedWindow) => this.unTrackWindow(trackedWindow.xid));
        debug('stopped listening for windows');
    }
    initExtensionState() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const oldState = JSON.parse(this.settings.get_string('extension-state'));
                yield new Promise((resolve) => utils_1.setTimeout(resolve, 200));
                for (let i = 0; i < oldState.length; i++) {
                    const oldWindowState = oldState[i];
                    const window = yield this.getWindow(oldWindowState.xid);
                    if (!window || !window.get_wm_class_instance() || window.get_window_type() != Meta_6_1.WindowType.NORMAL) {
                        continue;
                    }
                    debug(`restoring window: ${JSON.stringify(oldWindowState)}`);
                    yield this.trackWindow(oldWindowState.xid, window);
                    if (oldWindowState.hidden) {
                        this.hideWindow(oldWindowState.xid);
                    }
                    else {
                        this.showWindow(oldWindowState.xid);
                    }
                }
            }
            catch (ex) {
                debug(`failed to parse initial state: ${ex}`);
            }
        });
    }
    initValues() {
        try {
            // Get the already saved data
            this.mttData = JSON.parse(this.settings.get_string('mtt-data'));
        }
        catch (_) {
            debug('could not parse the settings data, resetting it.');
            this.mttData = [];
        }
    }
    trackWindow(xid, metaWindow) {
        return __awaiter(this, void 0, void 0, function* () {
            // Get the class name
            const className = metaWindow.get_wm_class_instance();
            if (className == null) {
                debug(`className is null for xid: ${xid}`);
                return;
            }
            // Get the mtt infor from the data
            const mttInfo = this.mttData.find((data) => data.className === className);
            // Check if we have the class name in our mtt data
            if (mttInfo && mttInfo.enabled && this.trackedWindows.findIndex((trackedWindow) => trackedWindow.xid == xid) < 0) {
                // Find the app from pid
                const app = Shell_0_1_1.WindowTracker.get_default().get_window_app(metaWindow);
                if (app == null) {
                    debug(`app is null for xid/className: ${xid}/${className}`);
                    return;
                }
                // Get the icon
                const icon = app.create_icon_texture(16);
                this.addTray(xid, icon);
                // Add window info to tracked windows
                this.trackedWindows = [
                    ...this.trackedWindows,
                    {
                        hidden: false,
                        className,
                        xid,
                    },
                ];
                this.settings.set_string('extension-state', JSON.stringify(this.trackedWindows));
            }
        });
    }
    unTrackWindow(xid) {
        return __awaiter(this, void 0, void 0, function* () {
            // Get the tracked window
            const trackedWindow = this.trackedWindows.find((trackedWindow) => trackedWindow.xid === xid);
            // Check if tracked window exist
            if (trackedWindow) {
                const window = yield this.getWindow(xid);
                if (window && trackedWindow.hidden == true) {
                    this.showWindow(trackedWindow.xid);
                }
                this.removeTray(xid);
                this.trackedWindows = this.trackedWindows.filter((trackedWindow) => trackedWindow.xid !== xid);
            }
        });
    }
    onSettingsChanged() {
        return __awaiter(this, void 0, void 0, function* () {
            this.initValues();
            const trackedClassNames = this.mttData
                .filter((mttInfo) => mttInfo.enabled === true)
                .map((mttInfo) => mttInfo.className);
            const nonExistingWindows = this.trackedWindows.filter((trackedWindow) => trackedClassNames.indexOf(trackedWindow.className) < 0);
            for (let i = 0; i < nonExistingWindows.length; i++) {
                const window = nonExistingWindows[i];
                yield this.unTrackWindow(window.xid);
            }
            const existingWindows = Shell_0_1_1.Global.get().get_window_actors();
            for (let i = 0; i < existingWindows.length; i++) {
                const window = existingWindows[i].get_meta_window();
                if (window.get_window_type() !== Meta_6_1.WindowType.NORMAL || !window.get_wm_class_instance()) {
                    continue;
                }
                const xid = yield utils_1.guessWindowXID(existingWindows[i].get_meta_window());
                if (xid) {
                    yield this.trackWindow(xid, existingWindows[i].get_meta_window());
                }
            }
        });
    }
    addTray(xid, icon) {
        // Create a new button from given window id
        const newButton = new Button(0, xid);
        const iconBox = new St_1_0_1.Bin({
            style_class: 'system-status-icon',
            y_align: Clutter_6_1.ActorAlign.CENTER,
        });
        iconBox.set_child(icon);
        newButton.add_actor(iconBox);
        // Connect to click event for hiding/showing
        newButton.connect('button-press-event', () => {
            // Get the tracked window
            const trackedWindow = this.trackedWindows.find((trackedWindow) => trackedWindow.xid === xid);
            // Check if tracked window exist
            if (trackedWindow) {
                // If window is hiden, show it else hide it
                if (trackedWindow.hidden) {
                    this.showWindow(trackedWindow.xid);
                }
                else {
                    this.hideWindow(trackedWindow.xid);
                }
                this.settings.set_string('extension-state', JSON.stringify(this.trackedWindows));
            }
        });
        // Add actor to status area
        panel.addToStatusArea(xid, newButton);
        return newButton;
    }
    removeTray(xid) {
        // If actor exists in status area, destroy it
        if (panel.statusArea[xid]) {
            panel.statusArea[xid].destroy();
        }
    }
    hideWindow(xid) {
        var _a;
        // Get the window for given id
        const window = this.trackedWindows.find((mttWindow) => mttWindow.xid === xid);
        // Do nothing if window does not exists
        if (window == null) {
            return;
        }
        // Hide the window from user
        debug(`hiding window: ${window.xid}/${window.className}`);
        (_a = Wnck_3_0_1.Screen.get_default()) === null || _a === void 0 ? void 0 : _a.force_update();
        const wnckWindow = Wnck_3_0_1.Window.get(parseInt(xid));
        if (wnckWindow) {
            wnckWindow.set_skip_pager(true);
            wnckWindow.set_skip_tasklist(true);
            wnckWindow.minimize();
            window.hidden = true;
        }
    }
    showWindow(xid) {
        var _a;
        // Get the window for given id
        const window = this.trackedWindows.find((mttWindow) => mttWindow.xid === xid);
        // Do nothing if window does not exists
        if (window == null) {
            return;
        }
        // Show the window to user
        debug(`showing window: ${window.xid}/${window.className}`);
        (_a = Wnck_3_0_1.Screen.get_default()) === null || _a === void 0 ? void 0 : _a.force_update();
        const wnckWindow = Wnck_3_0_1.Window.get(parseInt(xid));
        if (wnckWindow) {
            wnckWindow.set_skip_pager(false);
            wnckWindow.set_skip_tasklist(false);
            wnckWindow.unminimize(Math.floor(Date.now() / 1000));
            window.hidden = false;
        }
    }
    getWindow(xid) {
        return __awaiter(this, void 0, void 0, function* () {
            const currentWindowsActors = Shell_0_1_1.Global.get().get_window_actors();
            for (let i = 0; i < currentWindowsActors.length; i++) {
                const currentWindow = currentWindowsActors[i].get_meta_window();
                const currentXid = yield utils_1.guessWindowXID(currentWindow);
                if (currentXid === xid) {
                    return currentWindow;
                }
            }
        });
    }
}
exports.WindowListener = WindowListener;


/***/ }),
/* 7 */
/***/ (function(module, exports) {

module.exports = imports.gi.St;


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.getCurrentExtensionSettings = exports.getCurrentExtension = exports.ExtensionState = exports.ExtensionType = void 0;
var ExtensionType;
(function (ExtensionType) {
    ExtensionType[ExtensionType["SYSTEM"] = 1] = "SYSTEM";
    ExtensionType[ExtensionType["PER_USER"] = 2] = "PER_USER";
})(ExtensionType = exports.ExtensionType || (exports.ExtensionType = {}));
var ExtensionState;
(function (ExtensionState) {
    ExtensionState[ExtensionState["ENABLED"] = 1] = "ENABLED";
    ExtensionState[ExtensionState["DISABLED"] = 2] = "DISABLED";
    ExtensionState[ExtensionState["ERROR"] = 3] = "ERROR";
    ExtensionState[ExtensionState["OUT_OF_DATE"] = 4] = "OUT_OF_DATE";
    ExtensionState[ExtensionState["DOWNLOADING"] = 5] = "DOWNLOADING";
    ExtensionState[ExtensionState["INITIALIZED"] = 6] = "INITIALIZED";
    // Used as an error state for operations on unknown extensions,
    // should never be in a real extensionMeta object.
    ExtensionState[ExtensionState["UNINSTALLED"] = 99] = "UNINSTALLED";
})(ExtensionState = exports.ExtensionState || (exports.ExtensionState = {}));
exports.getCurrentExtension = () => imports.misc.extensionUtils.getCurrentExtension();
exports.getCurrentExtensionSettings = () => imports.misc.extensionUtils.getSettings();


/***/ }),
/* 9 */
/***/ (function(module, exports) {

module.exports = imports.gi.Shell;


/***/ }),
/* 10 */
/***/ (function(module, exports) {

module.exports = imports.gi.Meta;


/***/ }),
/* 11 */
/***/ (function(module, exports) {

module.exports = imports.gi.Wnck;


/***/ }),
/* 12 */
/***/ (function(module, exports) {

module.exports = imports.gi.Clutter;


/***/ })
/******/ ])["default"];